package reseauRoutier;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.TreeSet;

import parcours.Chemin;
import parcours.ParcoursSimple;
import grapheX.*;

public class Test{
	/**
	 * @param args
	 */
	public static void main(String args[]){
		
		HashSet<Sommet> HS = new HashSet<Sommet>();
		Sommet s = new Sommet("a");
		HS.add(s);
		if(HS.contains(new Sommet("a")))
			System.out.println(true);
		
		ReseauRoutier reseauRoutier = new ReseauRoutier();
		reseauRoutier.addPointRoute("Nice", 43.7034, 7.2663);
		reseauRoutier.addPointRoute("Cagnes");
		reseauRoutier.addPointRoute("Sophia");
		reseauRoutier.addPointRoute("Villeneuve",	43.63,7.14 );
		reseauRoutier.addPointRoute("Cagnes");
		System.out.println("arc Nice Cagnes");
		reseauRoutier.addArcRoutier("Nice", "Cagnes","A8", 13);
		reseauRoutier.addArcRoutier("Cagnes", "Nice","A8", 13);		
		reseauRoutier.addArcRoutier("Cagnes","Villeneuve","A8", 7);
		reseauRoutier.addArcRoutier("Villeneuve","Cagnes","A8", 7);
		reseauRoutier.addArcRoutier("Villeneuve","Sophia","A8", 23);
		reseauRoutier.addArcRoutier("Villeneuve","Sophia","N7", 14);
		reseauRoutier.addArcRoutier("Sophia","Villeneuve","N7", 14);
		reseauRoutier.addArcRoutier("Sophia","Villeneuve","A8", 23);
		
		System.out.println("=====================================");
		System.out.println(reseauRoutier);
		System.out.println("=====================================");
		
		HashMap<Sommet, Integer> next = reseauRoutier.getNextPointRoute("Nice");
		System.out.println("Points suivants Nice");
		System.out.println(next);
        next = reseauRoutier.getNextPointRoute("Villeneuve");
		System.out.println("Points suivants Villeneuve");
		System.out.println(next);
		System.out.println("Points suivants Sophia");
		System.out.println(next);
		System.out.println("=====================================");
		System.out.println(reseauRoutier);
	
		
		System.out.println("=====================================");
		ParcoursSimple ps = new ParcoursSimple(reseauRoutier.reseau);
		System.out.println("Chemins de Sophia = ");
		ArrayList<Chemin> chemins = ps.chemins(reseauRoutier.getPointRoute("Sophia"));
		for (Chemin c : chemins) {
			System.out.println(c);
		}
			
		System.out.println("=====================================");
		System.out.println("Chemins de Nice = ");
		chemins = ps.chemins(reseauRoutier.getPointRoute("Nice"));
		for (Chemin c : chemins) {
			System.out.println(c);
		}
		
		System.out.println("=====================================");
		System.out.println("Chemins de Villeneuve = ");
		chemins = ps.chemins(reseauRoutier.getPointRoute("Villeneuve"));
		
		for (Chemin c : chemins) {
			System.out.println(c);
		}
		
		
		System.out.println("=====================================");		
		System.out.println("=====================================");
		System.out.println("de Nice a Sophia : ");
		afficher(reseauRoutier.cheminsDeA("Nice","Sophia"));
		System.out.println("de Sophia a Nice : ");
		afficher(reseauRoutier.cheminsDeA("Sophia","Nice"));		
		System.out.println("de Sophia a villeneuve : ");
		afficher(reseauRoutier.cheminsDeA("Sophia","Villeneuve"));	
		System.out.println("de Sophia a Cagnes : ");
		afficher(reseauRoutier.cheminsDeA("Sophia","Cagnes"));			
		
		
		
	}

	private static void afficher(TreeSet<Chemin> cheminsDeA) {
		for (Chemin s : cheminsDeA)
			System.out.println("\tab" + s);
		
	}
}

