package reseauRoutier;

import grapheX.Arc;
import grapheX.Identifiable;

//Cette classe implements comparable car Arc l'implmente mais on a besoin d'autre chose...
//On gagenrait comme en cours  utiliser des comparateurs externes.
public class ArcRoutier<S extends Identifiable> extends grapheX.Arc{

	String intitule; 
	
	
	public ArcRoutier(S depart, S arrive, int distance, String intitule) {
		super(depart, arrive,distance);
		this.intitule = intitule;
	}


	@Override
	public String toString() {
		return "AR[" + intitule + "-"+ this.valeur()+":" + this.origine() +"->" + this.destination()+ "]";
	}


	@Override
	public int hashCode() {
		//System.out.println("hash" + this + "") ;
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result
				+ ((intitule == null) ? 0 : intitule.hashCode());
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		//System.out.println("compare" + this + ":" + obj);
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		ArcRoutier other = (ArcRoutier) obj;
		if (intitule == null) {
			if (other.intitule != null)
				return false;
		} else if (!intitule.equals(other.intitule))
			return false;
		return super.equals(obj);
	}


	public int compareTo(ArcRoutier a) {
		if (this.valeur() < a.valeur() )
			return -1;
		else if  (this.valeur() == a.valeur() )	
			return 0;
		else
			return 1;
	
 }

	
	
	
	
}
